/*==============================================================================
  **CMS**=C_INC
 
  Abs:  BPM function codes
 
  Name: bpmfunc.hc
 
  Prev: None
 
  Auth: 24-Sep-1990   L. Patmore
  Revw: 15-Oct-1990   R. Sass
 
--------------------------------------------------------------------------------
 
  Mod:  
        11-Jan-2005, Mike Zelazny (zelazny):
            Remove obsolete function code BPMO_UNLOCK.
        19-Feb-1999, Tony Gromme (TEG):
            Add BPMO_GETREMDAT for getting around message service size limit.
        16-Dec-1997, Tony Gromme (TEG):
            New function codes BPMO_RINQABO_INIT, BPMO_RINQABO_SCAN, and
            BPMO_RINQABO_MEAS for PEP2 ring beam abort data monitoring and
            retrieval.
        24-Aug-1994, P. Grossberg (PJG):
            Add connect/disconnect messages for FFBK (for new PT01 loop which
            gets measurements from old PT01 feedback).
        07-May-1992, T. Gromme (TEG):
            Filled in the rest.
 
==============================================================================*/
 
#ifndef BPMFUNC_HC
 
/* BPM function codes */
   /*  Note that the _PROC function code is always precisely one more  */
   /*  than the corresponding _PREP code.  This is necessary.          */
 
#define BPMO_CALB_PREP      0x0101
#define BPMO_CALB_PROC      0x0102
#define BPMO_CALTOR_PREP    0x0103
#define BPMO_CALTOR_PROC    0x0104
#define BPMO_CAL_RESTORE    0x0105
#define BPMO_CLR_SCP        0x0107
#define BPMO_BPMPINIT       0x0109
#define BPMO_PSUINIT        0x010A
#define BPMO_PDU_REINIT     0x010B
#define BPMO_MEAS_STOP      0x010D
#define BPMO_CAN_DEF        0x010E
#define BPMO_NOGATE_PREP    0x010F
#define BPMO_NOGATE_PROC    0x0110
#define BPMO_ACCEPT_PUBLIC  0x0118
#define BPMO_GETREMDAT      0x0119
#define BPMO_BUFRING_CRE    0x0120
#define BPMO_BUFRING_DEL    0x0122
#define BPMO_FDBK_CONNECT   0x0123
#define BPMO_FDBK_DISCNCT   0x0124
#define BPMO_FDBK_SUSPEND   0x0125
#define BPMO_TORO_CIRC_GET  0x0129
#define BPMO_RINQABO_INIT   0x012A
#define BPMO_RINQABO_SCAN   0x012B
#define BPMO_RINQABO_MEAS   0x012D
#define BPMO_MEAS_PREP      0x0131
#define BPMO_MEAS_PROC      0x0132
#define BPMO_WIRE_PREP      0x0133
#define BPMO_WIRE_PROC      0x0134
#define BPMO_RINQDSP_BOOT   0x014F
#define BPMO_DUMP_RINQDSP   0x0150
#define BPMO_SHO_RBUFS      0x0151
#define BPMO_CHK_PDUYYCHANS 0x0152
#define BPMO_TIMING_ADJ     0x0153
#define BPMO_BUFRING_SUSP   0x0154
 
 
/* FFBK function codes */
   /*  Included here even though never used by BPM code, only by */
   /*  "new" and "old" fast feedback.                            */
 
#define FFBK_FDBK_CONNECT   0x0A23
#define FFBK_FDBK_DISCNCT   0x0A24
 
#define BPMFUNC_HC
#endif
 
