/*=============================================================================
 
  Name: dbGlob.h

  Abs:  This include file contains external definitions of GLOBAL variables for the  
        the slc-aware IOC prototype for the db processes 
        
        Reference LCLS Controls | Facilities |SLC-Aware IOC |  
	   Database Service (DBS) Design Document 
 

  Auth: 4 SEP-2004, drogind created 
  Rev: 17 DEC-2004, drogind modified prototype code to production standards
 
-----------------------------------------------------------------------------*/
#include "copyright_SLAC.h"    
/*----------------------------------------------------------------------------- 
  Mod:  (newest to oldest)  
        DD-MMM-YYYY, My Name:
           Changed such and such to so and so. etc. etc.
        DD-MMM-YYYY, Your Name:
           More changes ... The ordering of the revision history 
           should be such that the NEWEST changes are at the HEAD of
           the list.
 
=============================================================================*/

#ifndef INCdbGlobH
#define INCdbGlobH 

#ifdef __cplusplus
extern "C" {
#endif
#include "slcGlob.h"
#include "dbGlob.h"         /* dbRecvDiags_s, dbSendDiags_s */
#include "dbRecv.h"         /* dbRecvDiags_ts */
#include "dbSend.h"         /* dbSendDiags_ts */
#include    <epicsMutex.h>  /* epicsMutexId */
#include "db_micro_struc.h"
#define OFF_ST0_HSHL 11 /* offset in st0 block for hash table size */
#define OFF_ST0_HTBL 12 /* offset in st0 block of hash offsets */

#define SIZE_UPS 11     /* word size of ups block */
#define OFF_UPS_FLINK 0 /* word offset of flink (nxth) element within ups block */
#define OFF_UPS_NEXTP 2 /* word offset of nextp element within ups block */
#define OFF_UPS_NEXTC 4 /* word offset of nextc element within ups block */
#define OFF_UPS_NLEN 6  /* word offset of nlen element within ups block */
#define OFF_UPS_CATN 8  /* word offset of catn element within ups block */
#define OFF_UPS_UNIT 9  /* word offset of unit element within ups block */
#define OFF_UPS_NSUB 10  /* word offset of nsub element within ups block */

#define SIZE_SUB_BYTES 8 /* byte size of sub block */
#define SIZE_SUB       4   /* word size of sub block */
#define OFF_SUB_SPTR_B 4   /* byte offset of sptr */
#define OFF_SUB_SPTR 2    /* word offset into supertype num */
                           /*                             element within sub block */
#define OFF_SUB_SUPN_B 1   /* byte offset of supn (supertype num) within sub block */
#define OFF_SUB_SLEN_B 2   /* byte offset of slen (word length of ST data in ST) of sub block */
#define OFF_SUB_FMT_B 3   /* byte offset of fmt (I,A,R,Z,S,T) of sub block */

#define JUST_BOOTED_BIT    0x80000000  /* both micro & dbex have this bit set */
                                       /*  after initial boot or restart      */
#define MAX_STX        4  /* max number of supertype blocks downloaded */
/* global variables to db tasks */
extern unsigned char  dbsendReceipts;   /* rolling receipt count */
extern epicsBoolean   dbsendAllUpdates; /* flag to check if we've lost connection,*/
                                        /* then regained it and should send updates */  
/* get microname from env via getMicroname() and store here  */
extern unsigned long dblongmicro;   

/* DBEX's message service id.  */
extern const char v018_c4[4];      

/* Public structure of pointers to memory allocated to hold supertype */
/*  blocks for this micro. */    
extern dbsuptype_tu *dbnodes_a[MAX_STX];
 
/* diag, watchdog data */
extern dbdiag_ts    dbdiag_s;         

/* dictionary */
extern void * dbdict_p;
extern int dbdictSize;

/* dbVersion */
  extern char dbVersion_a[8];              /* VMS logical  Ddbf$version */

/* dbex_up */
extern epicsBoolean dbex_up;  

/* dbRWMutex */
extern epicsMutexId dbRWMutex_ps;

/* free lists */
extern void *dblistSmFreeList_p;
extern void *dblistBigFreeList_p;

extern void * dbdictNameTrpFreeList_p;    /* pointer to dictNameTriplet_ts free list */
extern void * dbdictNameSglFreeList_p;    /* pointer to dictNameSgl_ts free list */
extern void * dbdictPUSFreeList_p;        /* pointer to dictPUS_ts free list */
extern void * dbdictPFreeList_p;          /* pointer to dictP_ts free list */
extern void * dbdictUFreeList_p;          /* pointer to dictU_ts free list */
extern void * dbdictSFreeList_p;          /* pointer to dictS_ts free list */

/* DBS Diagnostics */
extern dbRecvDiags_ts   dbRecvDiags_s;    /* global diagnostics for dbRecv thread */
/* diagnostics */
extern dbSendDiags_ts dbSendDiags_s;      /* global diagnostics for dbSend thread */

#ifdef __cplusplus
}
#endif

#endif /*INCdbGlobH*/
