/*=============================================================================
 
  Name: dbRecv.h

  Abs:  Public prototypes for dbRecv.c   
        Reference LCLS Controls | Facilities |SLC-Aware IOC |  
	   Database Service (DBS) Design Document 
        Reference RMX_DBS dbmain.c 

  Auth: 4 AUG 2004, drogind created using msgRecv.h as a template
  Rev: 17 DEC-2004, drogind modified prototype code to production standards
 
-----------------------------------------------------------------------------*/
#include "copyright_SLAC.h"    
/*----------------------------------------------------------------------------- 
  Mod:  (newest to oldest)  
        DD-MMM-YYYY, My Name:
           Changed such and such to so and so. etc. etc.
        DD-MMM-YYYY, Your Name:
           More changes ... The ordering of the revision history 
           should be such that the NEWEST changes are at the HEAD of
           the list.
 
=============================================================================*/

#ifndef INCdbRecvH
#define INCdbRecvH 

#ifdef __cplusplus
extern "C" {
#endif

/* dbRecv diagnostics structure; global variable inited in dbRecv.c */
typedef struct {
  unsigned short dbexUpState;      /*current DBEX state; 1 = up ; 0 = down */
                                   /* maps to bi record; which is epicsEnum16 = u.s.*/
  double         dbexUpdCnt;       /*total # of dbex updates recv'ed */
  double         dbexUpdDropCnt;   /*total # of dbex updates dropped due to err */
  epicsTimeStamp dbexLastUpdTime;  /*time of last dbex update */
  double         dbexDownCnt;      /*total # of times DBEX was flagged as down */

  char           dbVersion_a[8];   /*Database version (major/minor)*/
  unsigned long  dbexSockConnCnt;  /*total # of times proxy conn is established */
  int            dbexSockConnStatus;/*current dbex proxy conn state; 1=up; 0=down */
  unsigned long  dbexDiagCnt;      /*total # of diagnostic msgs recv'ed */
  /* wanted : ? */
  /*epicsTimeStamp slcLastAckTime;*/   /*time of last slc ack to dbex */
  /*double         totUpdToAckTime;*/  /*total time-use to calc average times */
  /*double         avgUpdToAckTime;*/  /*avg delta time bet time of recv and send of ack*/
  /*double         maxUpdToAckTime;*/  /*max delta time bet time of recv and send of ack */
} dbRecvDiags_ts; 

  epicsShareFunc void epicsShareAPI dbRecvThread(void);

#ifdef __cplusplus
}
#endif

#endif /*INCdbRecvH*/
