/*=============================================================================
 
  Name: dbST0.h

  Abs:  Public prototypes for dbST0.c 
        Include for VMS-host; host-VMS conversion utilities for DBEX tcp messages  
        Reference LCLS Controls | Facilities |SLC-Aware IOC |  
	   Database Service (DBS) Design Document 
 

  Auth: 4 SEP-2004, drogind created 
  Rev: 17 DEC-2004, drogind modified prototype code to production standards
 
-----------------------------------------------------------------------------*/
#include "copyright_SLAC.h"    
/*----------------------------------------------------------------------------- 
  Mod:  (newest to oldest)  
        DD-MMM-YYYY, My Name:
           Changed such and such to so and so. etc. etc.
        DD-MMM-YYYY, Your Name:
           More changes ... The ordering of the revision history 
           should be such that the NEWEST changes are at the HEAD of
           the list.
 
=============================================================================*/
#ifndef DBST0_HM  /* guard macro */
#define DBST0_HM  /* guard macro */
#ifdef __cplusplus
extern "C" {
#endif
/* slc global vars */
#include     "slcGlob.h"

/* macro definitions */

/* structure definitions */
typedef struct
{
  int4u max;                     /* max length of list (words; includes this hdr) */
  int4u cur;                     /* current length of list */
} dbST0header_ts;
typedef struct
{   
  int2u   headerw[11];           /* packed supertype header */
  int2u   hshl;                  /* size of hash array */
  int4u   hTbl[DBHASH];          /* Hash table - array of offsets */
  int2u   hcTbl[DBHASH];         /* Counts of nodes in above array */
} suptype0_ts;

/* prototype definitions */
vmsstat_t  dbST0Convert (void);
void dbST0printlist (dbST0header_ts * const dbdata_pp);
#ifdef __cplusplus
}
#endif

#endif  /* DBST0_HM guard macro */
