/*=============================================================================
 
  Name: dbSend.h

  Abs:  Public prototypes for dbSend.c   
        Reference LCLS Controls | Facilities |SLC-Aware IOC |  
	   Database Service (DBS) Design Document 
        Reference RMX_DBS dbmain.c 

  Auth: 4 AUG 2004, drogind created 
  Rev: 17 DEC-2004, drogind modified prototype code to production standards
 
-----------------------------------------------------------------------------*/
#include "copyright_SLAC.h"    
/*----------------------------------------------------------------------------- 
  Mod:  (newest to oldest)  
        DD-MMM-YYYY, My Name:
           Changed such and such to so and so. etc. etc.
        DD-MMM-YYYY, Your Name:
           More changes ... The ordering of the revision history 
           should be such that the NEWEST changes are at the HEAD of
           the list.
 
=============================================================================*/

#ifndef INCdbSendH
#define INCdbSendH 

#ifdef __cplusplus
extern "C" {
#endif

/* dbSend diagnostics structure; global variable inited in dbSend.c */
/* These diagnostics are general, and not job specific */
typedef struct {
  unsigned long  slcUpdCnt;        /*total # of ST 2 or 3 transmissions sent */
  unsigned long  slcUpdDropCnt;    /*total # of ST 2 or 3 trans dropped due to err */
  unsigned long  ctlAckCnt;        /*total # of Acks rec'ed on ctl socket from dbex */
  unsigned long  slcTimeoutAckCnt; /*total # of dbex Acks timing out; all jobs */  
  unsigned long  slcInvAckCnt;     /*total # of invalid Acks (receipt byte not what expected) */ 
  epicsTimeStamp slcLastUpdTime;   /*time of last ST 2 or 3 update to VMS; any job */
  epicsTimeStamp ctlLastAckTime;   /*time of last dbex ack */
  double         totUpdToAckTime;  /*total time-use to calc average times */
  double         avgUpdToAckTime;  /*avg delta time bet time of send and receipt of valid ack*/
  double         maxUpdToAckTime;  /*max delta time bet time of send and receipt of valid ack */
  unsigned long  ctlSockConnCnt;   /*total # of times proxy conn is established for ctl socket */
  int            ctlSockConnStatus; /*current ctl proxy conn state; 1=up; 0=down */
  double         dbexLastDisconnTime; /*total time of last dbex disconnect, as monitored */
                                      /* by dbSend thread */
  double         ctlLastDisconnTime; /*total time of last ctl socket disconnect, as monitored */
                                      /* by dbSend thread */

} dbSendDiags_ts; 

void dbSendCleanup(void);

epicsShareFunc void epicsShareAPI dbSendThread(void);

vmsstat_t dbWriteDbs(const int sd,
					 const unsigned short id,
					 const unsigned short *max_bytecount_p,
					 dbsndrcvbuf_ts       *outmsg_ps );

#ifdef __cplusplus
}
#endif

#endif /*INCdbSendH*/
