/*=============================================================================
 
  Name: dbcheck.h

  Abs:  DBS prototypes for dbcheck.c   
        Reference web pages on LCLS Controls | Facilities |SLC-Aware IOC | :
                        Database Service (DBS) Design Document 
                        Functional Requirements | SLC Database Service (DBS)
                        Database Input/Output Utilities

  Auth:17 DEC 2004, drogind created
  Rev: DD-MMM-YYYY, My Name:
 
-----------------------------------------------------------------------------*/
#include "copyright_SLAC.h"    
/*----------------------------------------------------------------------------- 
  Mod:  (newest to oldest)  
        DD-MMM-YYYY, My Name:
           Changed such and such to so and so. etc. etc.
        DD-MMM-YYYY, Your Name:
           More changes ... The ordering of the revision history 
           should be such that the NEWEST changes are at the HEAD of
           the list.
 
=============================================================================*/

#ifndef INCdbcheckH
#define INCdbcheckH 

#include "dblist.h"
#include "dbhash.h"

#ifdef __cplusplus
extern "C" {
#endif

  vmsstat_t dbcheckFreeLists(void);
  vmsstat_t dbcheckWithWait(const dbheader_ts ** const db_pps);
  vmsstat_t dbcheck(const dbheader_ts ** const db_pps);
  vmsstat_t dbcheckHeader(const dbheader_ts * const db_ps, 
						  const epicsBoolean errOnZeroCur);
  vmsstat_t dbcheckPrim(const char * const prim_a, 
						const dbheader_ts ** const db_pps, 
						dbhEntry_ts ** dbhEntry_pps);
  vmsstat_t dbcheckExists (void);


#ifdef __cplusplus
}
#endif

#endif /*INCdbcheckH*/
 
