/*=============================================================================
 
  Name: dbget.h

  Abs:  Public prototypes for dbget.c   
        Reference web pages on LCLS Controls | Facilities |SLC-Aware IOC | :
                        Database Service (DBS) Design Document 
                        Functional Requirements | SLC Database Service (DBS)
                        Database Input/Output Utilities

  Auth:17 DEC 2004, drogind created
  Rev: DD-MMM-YYYY, My Name:
 
-----------------------------------------------------------------------------*/
#include "copyright_SLAC.h"    
/*----------------------------------------------------------------------------- 
  Mod:  (newest to oldest)  
        DD-MMM-YYYY, My Name:
           Changed such and such to so and so. etc. etc.
        DD-MMM-YYYY, Your Name:
           More changes ... The ordering of the revision history 
           should be such that the NEWEST changes are at the HEAD of
           the list.
 
=============================================================================*/

#ifndef INCdbgetH
#define INCdbgetH 

#include <epicsTypes.h>         /* epicsBoolean */

#ifdef __cplusplus
extern "C" {
#endif

  vmsstat_t dbgetUnitAsString(const unsigned short unit, char * const unit_a);
  void dbgetCatPUSName(const char * prim_a, const char * unit_a, const char * secn_a,
		       char * primUnitSecn_a);
  void dbgetBlkPad (char *name_pa);
  void dbgetNullToBlank (unsigned long *name_pa);
  char dbgetFormat (const char * const prim_a, const char * const secn_a);
  int dbgetWidth   (const char * const prim_a, const char * const secn_a);
  int dbgetCount   (const char * const prim_a, const char * const unit_a, 
	            const char * const secn_a);
  vmsstat_t dbgetMeta (const char * const prim_a, 
		       const char * const unit_a, 
		       const char * const secn_a, 
		       char * format, 
		       int * width, 
		       int * count,
			   int * supn);
					  
  const char * dbgetVersion (void);
  int dbgetUnitCount (const char * const prim_a);
  /*  epicsBoolean dbgetExists(void);--> slcGetDbExists */

#ifdef __cplusplus
}
#endif

#endif /*INCdbgetH*/
