/*=============================================================================
 
  Name: dbsList.h

  Abs:  DBS prototypes (helper routines) for dblist.c   
        Reference LCLS Controls | Facilities |SLC-Aware IOC |  
	   Database Service (DBS) Design Document 
        Reference RMX_DBS dbmain.c 

  Auth: 1 DEC 2004, drogind created
  Rev: 17 DEC-2004, drogind modified prototype code to production standards
 
-----------------------------------------------------------------------------*/
#include "copyright_SLAC.h"    
/*----------------------------------------------------------------------------- 
  Mod:  (newest to oldest)  
        DD-MMM-YYYY, My Name:
           Changed such and such to so and so. etc. etc.
        DD-MMM-YYYY, Your Name:
           More changes ... The ordering of the revision history 
           should be such that the NEWEST changes are at the HEAD of
           the list.
 
=============================================================================*/
#ifndef dbsList_HM  /* guard macro */
#define dbsList_HM  /* guard macro */
#ifdef __cplusplus
extern "C" {
#endif

#include "dblist.h"

#define    DBL_NBIG    20            /* number of big lists */
#define    DBL_NSM     900           /* number of small lists */
#define    DBL_SZBIG   1000          /* size in bytes of big list */
#define    DBL_SZSM    48            /* size in bytes of small list */
#define    DBL_WSZBIG  DBL_SZBIG/2   /* size in words of big list */
#define    DBL_WSZSM   DBL_SZSM/2    /* size in words of small list */
  /* make DBL_SZSM bigger than sizeof(dbheder_ts) */


/* prototype definitions */
  vmsstat_t dblistInitFreeLists (void);
  void dblistDelFreeLists (void);
  vmsstat_t dblistNew (const unsigned long bytes_to_allocate, 
					   const dbheader_ts ** const dbdata_pps);
  vmsstat_t dblistEnlarge (const unsigned long bytes_to_allocate, 
						   dbheader_ts ** const dbdata_pps);   
  vmsstat_t dblistAdd (const unsigned short bytes_in_elem,
					   const unsigned short  num_elems,
					   const void * addMe_p,
					   const dbheader_ts ** const db_pps);
  vmsstat_t  dblistPrint  (const dbheader_ts * const dblist_ps );
#ifdef __cplusplus
}
#endif

#endif  /* dbsList_HM guard macro */
