/*=============================================================================
 
  Name: dbshell.h

  Abs:  Public prototypes for dbshell.c   
        Reference web pages on LCLS Controls | Facilities |SLC-Aware IOC | :
                        Database Service (DBS) Design Document 
                        Functional Requirements | SLC Database Service (DBS)
                        Database Input/Output Utilities

  Auth:28 JAN 2005, drogind created
  Rev: DD-MMM-YYYY, My Name:
 
-----------------------------------------------------------------------------*/
#include "copyright_SLAC.h"    
/*----------------------------------------------------------------------------- 
  Mod:  (newest to oldest)  
        DD-MMM-YYYY, My Name:
           Changed such and such to so and so. etc. etc.
        DD-MMM-YYYY, Your Name:
           More changes ... The ordering of the revision history 
           should be such that the NEWEST changes are at the HEAD of
           the list.
 
=============================================================================*/

#ifndef INCdbshellH
#define INCdbshellH 


#ifdef __cplusplus
extern "C" {
#endif


  void dbshellDumpHash (void);
  void dbshellDumpHashFile (const char * const filename);
  void dbshellGetMeta  (const char * const prim_p, const char * const unit_p, 
						const char * const secn_p);

  void dbshellDump (const char * const prim_p, const char * const unit_p, 
				   const char * const secn_p);
  void dbshellGetUnits (const char * const prim_p);
  /*void dbshellEdit (char * prim_p, char * unit_p, char * secn_p, 
	char * const value1,... ); */
  /* dbshellDump should have prim, optional  unit, optional secn params */
  void dbshellGetExists (void);
  void dbshellGetVersion (void);
  void dbshellUpdate (const char * const jobName);
  void dbshellSetHashTableSize (int hashSize);
  void dbshellEdit  (const char * const prim_p, const char * const unit_p, 
		     const char * const secn_p, const char * const val_p);
  void dbshellEditST1  (const char * const prim_p, const char * const unit_p, 
		     const char * const secn_p, const char * const val_p);

#ifdef __cplusplus
}
#endif

#endif /*INCdbshellH*/
