/*=============================================================================
 
  Name: dbupdate.h

  Abs:  Public prototypes for dbupdate.c   
        Reference web pages on LCLS Controls | Facilities |SLC-Aware IOC | :
                        Database Service (DBS) Design Document 
                        Functional Requirements | SLC Database Service (DBS)
                        Database Input/Output Utilities

  Auth:17 DEC 2004, drogind created
  Rev: DD-MMM-YYYY, My Name:
 
-----------------------------------------------------------------------------*/
#include "copyright_SLAC.h"    
/*----------------------------------------------------------------------------- 
  Mod:  (newest to oldest)  
        DD-MMM-YYYY, My Name:
           Changed such and such to so and so. etc. etc.
        DD-MMM-YYYY, Your Name:
           More changes ... The ordering of the revision history 
           should be such that the NEWEST changes are at the HEAD of
           the list.
 
=============================================================================*/

#ifndef INCdbupdateH
#define INCdbupdateH 

#ifdef __cplusplus
extern "C" {
#endif
#include <epicsTime.h> /* epicsTimeStamp */

/* diagnostics, for updates, on a per-job basis */
typedef struct {
  unsigned long  updToVMSCnt;
  unsigned long  VMStoSlcAckGoodCnt;
  unsigned long  VMStoSlcAckDumpCnt;
  epicsTimeStamp lastUpdTime;
} dbupdateJobDiags_ts; 

  vmsstat_t dbupdateHiLo(const slcJob_te slcJobId_e, 
						 const short supn,
						 const unsigned long sptrLo,
						 const unsigned long sptrHi);

  void dbupdateCompress(const slcJob_te slcJobId_e,
						const short supn,
						const short xxxf);

  vmsstat_t dbupdate(const slcJob_te slcJobId_e);
  vmsstat_t dbupdateNoWait(const slcJob_te slcJobId_e);
  vmsstat_t dbupdateAll(void);
#ifdef __cplusplus
}
#endif

#endif /*INCdbupdateH*/
