/*=============================================================================

  Name: clustat.h

  Abs:  This file contains bit assignments for the CDSC secondary.
        the FECC version of the slc-aware IOC must discover itself from
		this bit after the slc database download.

  Auth: 14-oct-2005, diane fairley (DFAIRLEY): created
  Rev:  Debbie Rogind

-----------------------------------------------------------------------------*/

#include "copyright_SLAC.h"	/* SLAC copyright comments */
 
/*-----------------------------------------------------------------------------
 
  Mod:  (newest to oldest)  
         08-dec-2004, diane fairley (DFAIRLEY): added this header
 
=============================================================================*/


#ifndef clustat_H
#define clustat_H 

/* thest are shared with the SLC control system, if changed here they
   must be changed in ref_c_inc:clustat.hc
*/

 /* Bit assignments for CDSC bits. */

#define CDSC_VIRT      0x0001
#define CDSC_PHYS      0x0002
#define CDSC_SYTK      0x0004
#define CDSC_MULT      0x0008

#define CDSC_DBUG      0x0010
#define CDSC_TIME      0x0020
#define CDSC_BPMUX     0x0040
#define CDSC_BPMPSU    0x0080

#define CDSC_RING      0x0100
#define CDSC_NEWTIME   0x0200
#define CDSC_NEWMBCD   0x0400
#define CDSC_NEWMBCDTO 0x0800

#define CDSC_KISNET_CD 0x1000
#define CDSC_BITBUS_MASTER 0x2000
#define CDSC_FECC      0x4000     /* used as identifier for FECC slc-aware IOC */
#define CDSC_DMB_EXER  0x8000


#endif /*clustat_H*/

