/*=============================================================================

  Name: mgntAsync.h

  Abs:  Magnet database utility function prototypes

  Auth: 24-Oct-2005, D rogind         (DROGIND)
  Rev:  dd-mmm-yyyy, Reviewer's Name  (USERNAME)

-----------------------------------------------------------------------------*/

#include "copyright_SLAC.h"	/* SLAC copyright comments */
 
/*-----------------------------------------------------------------------------
 
  Mod:  (newest to oldest) 
        dd-mmm-yyyy, First lastname (USERNAME):
          comment
 
=============================================================================*/
#ifndef mgntAsync_H
#define mgntAsync_H

#include "slcTypes.h"      /* for vmsstat_t */
#include "mgntTypes.h"     /* for mgntUnitStruct_ts */
#include "dblist.h"        /* for dbheader_ts */
#include <dbAccess.h>      /* Epics Runtime Database        */
#include <dbAccessDefs.h>  /* dbPutField()                  */               
#include <dbFldTypes.h>    /* DBR_FLOAT,DBR_USHORT          */

void mgntAsyncThread(void);

/* returns true if Check should be performed */
epicsBoolean mgntAsyncCheckDoProceed(void);

vmsstat_t mgntAsyncPVToSlcFloat ( DBADDR *dbaddr_ps,
								  const dbheader_ts * const dblist_ps,
								  dbheader_ts **const dbdata_pps);
vmsstat_t mgntAsyncPVToSlcUShort ( DBADDR *dbaddr_ps,
								   const dbheader_ts * const dblist_ps,
								   dbheader_ts **const dbdata_pps,
								   mgntUnitStruct_ts * const unit_ps);
#endif /* mgntAsync_H */
