/*==============================================================================

  Abs:  Messages for the Magnet Facility

  Name: mgntdefMsg.h

  Rem:  Below are the magnet message strings to coorespond
        to the magnet message codes in mgntdef.hc
       
  Side: If this file is modified please update
       corresponding VAX message file
            mgntdef.msg

  Prev: None

  Auth: 26-Nov-1988, Nan Phinney      (NAN)
  Revw: dd-mmm-yyyy, Reviewer's Name  (USERNAME)

--------------------------------------------------------------------------------

  Mod:
        12-Jul-2003, K. Luchini (LUCHINI):
          Ported to Unix SLC-IOC Aware magnet facilty

==============================================================================*/

#ifndef mgntdefMsg_H
#define mgntdefMsg_H

#define MGNT_OKOK_MSG             "Magnet operation completed successfully"
#define MGNT_SUCCESS_MSG          "Magnet %.4s function successful to %.4s Dgrp= %.8s"
#define MGNT_NOUNITS_MSG          "No units selected for %.4s function to %.4s %.8s"
#define MGNT_ABORTED_MSG          "Magnet %.4s function to %.4s ABORTED in Dgrp %.8s"
#define MGNT_OPWRN_MSG            "Magnet %.4s function completed with WARNINGS to %.4s Dgrp= %.8s"
#define MGNT_OPERR_MSG            "Magnet %.4s function completed with ERRORs to %.4s Dgrp= %.8s"
#define MGNT_DBERR_MSG            "DATABASE error detected in magnet job!"
#define MGNT_TIMEOUT_MSG          "Magnet %.4s function TIMED OUT to %.4s Dgrp= %.8s"
#define MGNT_NETERR_MSG           "Network error on magnet %.4s function to %.4s Dgrp= %.8s"
#define MGNT_UNKFUNC_MSG          "Invalid Function Code in CSTR"
#define MGNT_NOTMAGPRIM_MSG       "Specified primary %.4s is not a magnet device."
#define MGNT_CATAGORY_MSG         "Invalid magnet command list primary: %.4s"
#define MGNT_LIST_TOO_SHORT_MSG   "List too short, %.4s not done to all units in %.4s"

#endif /* mgntdefMsg_H */




