/*=============================================================================

  Name: cvtUtil.h

  Abs:  This include file contains PUBLIC function prototypes for the  
        the slc-aware IOC prototype word and float conversion utility functions


  Auth: 29-dec-2004, diane fairley (dfairley): created
  Rev:  02 feb 2005 drogind

-----------------------------------------------------------------------------*/

#include "copyright_SLAC.h"	/* SLAC copyright comments */
 
/*-----------------------------------------------------------------------------
 
  Mod:  (newest to oldest) 
        09-dec-2004 dfairley:
		   added this header 
 
=============================================================================*/
#ifndef cvtUtil_H
#define cvtUtil_H 

void cvtSSwap(const unsigned short* s_p); 
void cvtLSwap(const unsigned long* l_p);
void cvtSSwapMove(const void* u2In_p, void* u2Out_p);
void cvtLSwapMove(const void* u4In_p, void* u4Out_p);
void cvtFloatVMSToIEEE(const void* r4In_p, void* r4Out_p);
void cvtFloatIEEEToVMS(const void* r4In_p, void* r4Out_p);
void cvtFromVMS(const char format, const int width,          
				const int count, const void * vmsData_p,
				void * const nativeData_p);             
void cvtToVMS(const char format, const int width,            /* place holder */
			  const int count, const void * nativeData_p, 
			  void * const vmsData_p);
void cvtULongtoUShorts(const unsigned long thelong,
					   unsigned short * hishort_p,
					   unsigned short * lowshort_p);
#endif /*cvtUtil_H*/


