/*=============================================================================

  Name: msgQUtil.h

  Abs:  all message queue utility prototypes

  Auth: 13-dec-2004, diane fairley (DFAIRLEY): created
  Rev:  02 feb 2005, Debbie Rogind

-----------------------------------------------------------------------------*/

#include "copyright_SLAC.h"	/* SLAC copyright comments */
 
/*-----------------------------------------------------------------------------
 
  Mod:  (newest to oldest)  
           26-Aug-2005, K. Luchini (LUCHINI):
              added msgQMsgProcess
 
=============================================================================*/

#ifndef msgQUtil_H
#define msgQUtil_H 

#include <epicsTime.h>  /* epicsTimeStamp   */

#include "slcTypes.h"   /* slcThread_te     */
#include "slcStructs.h" /* slcScpFunc_ts    */
#include "msgTypes.h"   /* MAX_MSG_* defines*/

vmsstat_t  messageQSend(const slcThread_te thrd_e, 
						const epicsBoolean wait_at_queue,
						const int msgBytes, 
						const void* msg_p );
vmsstat_t  messageQRecv(const slcThread_te thrd_e,
						const int msgBytes, 
						epicsTimeStamp *currentTime_ps,
						void* msg_p );
vmsstat_t  messageQCreate( const slcThread_te thrd_e, 
						   const int maxMsgs, 
						   const int maxMsgBytes );
void       messageQRelease(const slcThread_te thrd_e ); /* release msgs then the queue*/
void       messageQDestroy(const slcThread_te thrd_e ); /* destroy the queue */
vmsstat_t  msgQMsgRecv(const slcThread_te thrd_e, 
					   epicsTimeStamp* currentTime_ps,
					   void **const msg_pp);
vmsstat_t  msgQMsgReply(const slcThread_te thrd_e, const void* msg_p);
vmsstat_t  msgQGetBuffer( const unsigned long bytes, void **const msg_pp);
void       msgQFreeBuffer(unsigned long bytes, const void* msg_p); 
vmsstat_t  msgQSlcReply(const int func, const int bytes, const void* rMsg_p, void* sMsg_p); 
vmsstat_t  msgQSlcIssReply( const void* rMsg_p, const vmsstat_t iss); 
vmsstat_t  msgQMsgProcess( slcThread_te                thread_e, 
                           unsigned long               nr_func,
                           const slcScpFunc_ts * const scp_func_as,
                           const void          * const rMsg_p,
                           void                * const sMsg_p,
                           unsigned long       * const update_p );

#endif /*msgQUtil_H*/
