/*=============================================================================

  Name: slcGlob.h

  Abs:  This include file contains external definitions of GLOBAL variables for the  
        the slc-aware IOC   

  Auth: xx-jun-2004, diane fairley (DFAIRLEY): created
  Rev:  02 feb 2005, Debbie Rogind

-----------------------------------------------------------------------------*/

#include "copyright_SLAC.h"	/* SLAC copyright comments */
 
/*-----------------------------------------------------------------------------
 
  Mod:  (newest to oldest)  
        25-apr-2006 added slcGetLOCA2Name, slcCpyLOCA2Name (dfairley)
        25-Aug-2004 Added DBNODES (drogind)
		   
        DD-MMM-YYYY, My Name:
           Changed such and such to so and so. etc. etc.
        DD-MMM-YYYY, Your Name:
           More changes ... The ordering of the revision history 
           should be such that the NEWEST changes are at the HEAD of
           the list.
 
=============================================================================*/
#ifndef slcGlob_H
#define slcGlob_H 


/* epics includes */
#include    <epicsEvent.h>  /* epicsEventId */

/* slcIOC includes */
#include "slcStructs.h"       /* slcThread_ts, slcSocket_ts, etc. */
#include "tcpTypes.h"       /* MAX_SOCKETS */

/* global variables */
extern slcThread_ts slcThreads_as[MAX_THREADS];
extern slcSocket_ts slcSockets_as[MAX_SOCKETS];
extern slcJob_ts    slcJobs_as[MAX_SLC_JOBS];
extern char         slcIocName_a[5];
extern char         slcProxyIPAddr_a[16];
extern epicsEventId dbDownloadEvent_ps;
extern epicsBoolean dbExists;
extern epicsBoolean slcIocIsLittleEndian;
extern void *       slcSmMsgPvt_p; /* pointer to small-message pool */
extern void *       slcLrgMsgPvt_p;/* pointer to large-message pool */
extern execDiags_ts execDiagnostics_s;
extern epicsBoolean feccIOC;

/* function prototypes */
epicsThreadId       slcThreadGetTid(const slcThread_te thrd_e);
epicsMessageQueueId slcThreadGetMqId(const slcThread_te thrd_e);
unsigned long       slcThreadGetDestination(const slcThread_te thrd_e);

void          slcCpyIOCName(void);
char*         slcGetIOCName(void);

void          slcCpyProxyIPAddress(void);
char*         slcGetProxyIPAddress(void);

void          slcSetDbExists(const epicsBoolean val);
epicsBoolean  slcGetDbExists (void);

void          slcSetNotify(const epicsBoolean val);
epicsBoolean  slcGetNotify (void);

void   slcInitGlobals(void);
void   slcDbDownloadEventDestroy(void);

void          slcCpyLOCAName(void);
char*         slcGetLOCAName(void);

void          slcCpyLOCA2Name(void);
char*         slcGetLOCA2Name(void);

epicsBoolean  slcInitFeccIOC(void);
epicsBoolean  slcGetFeccIOC(void);
#endif /*slcGlob_H*/
