/*=============================================================================

  Name: slcMsg.h

  Abs: Message service function codes. This file contains function codes
       for the slc-aware-ioc

  Auth: 19-jul-2004, diane fairley (DFAIRLEY):
  Rev:  02 feb 2005, Debbie Rogind

-----------------------------------------------------------------------------*/

#include "copyright_SLAC.h"	/* SLAC copyright comments */
 
/*-----------------------------------------------------------------------------
 
  Mod:  (newest to oldest)
        21-Oct-2005 Deb Rogind (DROGIND)
		          Add MGNT_NOTIFY
        22-Apr-2005 Ron MacKenzie (ronm)
                  Add IOC_ASYNC
        22-Nov-2004 diane fairley:
		  renamed to slcMsg.h - no longer a prototype file
 
=============================================================================*/
#ifndef slcMsg_H  /* guard macro */
#define slcMsg_H  /* guard macro */

#define FUNC_IOC             0x0000           /* this is an unused VMS code*/
                                              /* not used by the micros, we are */
                                              /* taking it here to define all */
                                              /* slcIOC inter-thread msgs */

#define IOC_RESTART          (FUNC_IOC+1)     /* start all prototype threads */
#define IOC_STOP             (FUNC_IOC+2)     /* stop all prototype threads */
#define IOC_IOC_SLCNOTIFY    (FUNC_IOC+3)     /* tell msgHdlr to execute stop or restart*/
#define IOC_ASYNC            (FUNC_IOC+4)     /* cstrAsync tells Hdlr to exe a cycl func*/

#define BSAC_DATA            (FUNC_IOC+10)    /* data received from Epics MEASCNT */
#define BSAC_DONE            (FUNC_IOC+11)    /* data/Done received from Epics MEASCNT */
#define BSAC_SYNC_CTRL       (FUNC_IOC+12)    /* synch the BSAC CTRL record & HSTA */


/*dbs message definitions */
#define DB_RECV_STOP         (FUNC_IOC+19)    /* the db recv thread is stopped */
#define DB_SEND_STOP         (FUNC_IOC+20)    /* the db send thread is stopped */
#define DB_HDLR_STOP         (FUNC_IOC+21)    /* the db handler thread is stopped */
#define DB_RECV_START        (FUNC_IOC+22)    /* the db recv thread is started */
#define DB_SEND_START        (FUNC_IOC+23)    /* the db send thread is started */
#define DB_HDLR_START        (FUNC_IOC+24)    /* the db hdlr thread is started */
#define DB_DOWNLOAD_REQ      (FUNC_IOC+25)    /* request download */
#define DB_ACK_DBEX          (FUNC_IOC+26)    /* send an ack back to dbex  */
#define DB_DIAG_DBEX         (FUNC_IOC+27)    /* send diagnostic reply back to dbex  */
#define DB_CTL_ACK           (FUNC_IOC+28)    /* receive ack at CTL socket from dbex  */
#define DB_CTL_START         (FUNC_IOC+29)    /* start the db ctl thread  */
#define DB_CTL_STOP          (FUNC_IOC+30)    /* stop the db ctl thread  */
#define DB_CONVERT           (FUNC_IOC+31)    /* convert ST0 to dictionary */
#define DB_UPDATE            (FUNC_IOC+32)    /* send ST update(s) to Alpha */
#define DB_UPDATE_ALL        (FUNC_IOC+33)    /* send all job ST update(s) to Alpha */

#define MGNT_NOTIFY_CTRL     (FUNC_IOC+34)    /* message from CA Monitor callback for */
                                              /* a magnet epics CTRL record change */   
#define MGNT_NOTIFY_HSTA     (FUNC_IOC+35)    /* message from CA Monitor callback for */
                                              /* a magnet epics HSTA record change */ 
#define MGNT_NOTIFY_BDES     (FUNC_IOC+36)    /* message from CA Monitor callback for */
                                              /* a magnet epics BDES record change */
#endif /* slcMsg_H */

