/*=============================================================================

  Name: slcUtil.h

  Abs:  This include file contains prototype definitions for the  
        the slc-aware IOC miscellaneous utilities pertaining to threads

  Auth: 09-SEP-2004, Debbie Rogind (drogind):
  Rev:  02 feb 2005, Debbie Rogind

-----------------------------------------------------------------------------*/

#include "copyright_SLAC.h"	/* SLAC copyright comments */
 
/*-----------------------------------------------------------------------------
 
  Mod: 
        29-Sep-2005, K. Luchini (LUCHINI)
           Remove slcIocStop macro
        26-Aug-2005, K. Luchini (LUCHINI):
           Added macros slcIocStop(),slcGetThread()
           Added arg to slcCleanupThread()
           Remove macro slcStopThread() and add prototype for function
        11-Jul-2005, K. Luchini (LUCHINI):
           Added prototypes for slcStopThread,slcCleanupThread
           and slcPrintMsgheader
        08-Mar-2004, Ron MacKenzie:
           Change slcGetJobIndexByName() to slcGetJobEnumByName() 
        09-DEC-2004, diane fairley:
           Changed names, etc to meet coding standards
=============================================================================*/
#ifndef slcUtil_H
#define slcUtil_H 


#include "slcStructs.h"
#include "slcTypes.h"     /* for slcEnd */

slcThread_te  slcGetThreadEnumByTid(const epicsThreadId tid_ps);
slcThread_te  slcGetThreadEnumByName(const char * name_c);
slcJob_te     slcGetJobEnumByName(const char * const name_a);
unsigned long slcGetThreadDestinationByTid(const epicsThreadId tid_ps);
slcJob_te     slcGetJobEnumByThreadEnum(const slcThread_te thread_e);
slcJob_te     slcGetJobEnum(void);
void          slcCleanupThread(slcThread_te thread_e,int (*cleanupRoutine_pf)());
void          slcStopThread (slcThread_te thread_e);

#ifdef DEBUG_PRINT
void          slcPrintMsgheader(const msgheader_ts *msgheader, int debugFlag );
#else
#define       slcPrintMsgheader(msgheader,debugFlag) 
#endif
#ifdef slcGlob_H
#define       slcGetThread(thread_e)  ((((thread_e)>=slcExec) && (thread_e<slcEnd)) ? &slcThreads_as[(thread_e)] : NULL )
#endif
#endif /*slcUtil_H*/
