/*=============================================================================

  Name: tcpUtil.h

  Abs:   This include file contains function prototypes for the  
        the slc-aware IOC tcp  utility functions
        refer to web page LCLS Controls | Facilities | SLC-Aware IOC | General Purpose Utilities
 

  Auth: xx-aug-2004, drogind: created
  Rev:  02 feb 2005, Debbie Rogind

-----------------------------------------------------------------------------*/

#include "copyright_SLAC.h"	/* SLAC copyright comments */
 
/*-----------------------------------------------------------------------------
 
  Mod:  (newest to oldest) 
        22-mar-2005 dfairley removed lower-level getConnection calls from public
        11-feb-2005 dfairley added nonblocking socket support utilities
        29-Nov-2004 dfairley renamed with tcp at beginning
=============================================================================*/
#ifndef tcpUtil_H
#define tcpUtil_H 


#include "tcpTypes.h"  /* SOCKET */
#include "msgTypes.h"  /* fwd_hdr_ts */

/*vmsstat_t tcpGetConnection(const unsigned short proxyPort,  
						const unsigned short srvcPort,
						slcSocket_ts* sock_ps);*/

/*vmsstat_t tcpGetNonblockingConnection(const unsigned short proxyPort,  
									  const unsigned short srvcPort,
									  slcSocket_ts* sock_ps);*/

vmsstat_t tcpGetBuffer(const slcSocket_ts* sock_ps, 
					   const int    bytesReqd, 
					   int          *bytesRcvd_p,
					   fwd_hdr_ts   *fwd_p, 
					   void         *buf_p);

vmsstat_t tcpSendBuffer(const slcSocket_ts* sock_ps, const int msgBytes, const void * msg_p);


vmsstat_t tcpSockConnect(const slcThread_te thrd_e,
                         const unsigned short proxyport, 
						 const unsigned short hostport,
						 const float waitDeltaTime,
						 unsigned long *elapsedCount_p,
						 slcSocket_ts* sock_ps); 

vmsstat_t tcpSockNonblockingConnect(const slcThread_te thrd_e,
									const unsigned short proxyport, 
									const unsigned short hostport,
									const float waitDeltaTime,
									unsigned long *elapsedCount_p,
									slcSocket_ts* sock_ps); 

void tcpSockClose(slcSocket_ts* sock_ps);

epicsBoolean tcpSockCheck(const slcSocket_ts* sock_ps,
				  const slcThread_te recv_e,
				  const slcThread_te send_e,
				  const float waitDeltaTime,
				  unsigned long *elapsedCount_p);

vmsstat_t  tcpSockReadyForRead(const slcSocket_ts* sock_ps, unsigned short waitTime);

#endif /*tcpUtil_H*/


