/*=============================================================================

  Name: timeUtil.h

  Abs:  prototypes for time conversion routines
        since all message from the alpha are in vms format, and the
        slc database is stored on the slcIoc in vms format, the
        time conversion routines are all vms to host, and host to vms

  Auth: 29-nov-2004, diane fairley (DFAIRLEY):
  Rev:  02 feb 2005, Debbie Rogind

-----------------------------------------------------------------------------*/

#include "copyright_SLAC.h"	/* SLAC copyright comments */
 
/*-----------------------------------------------------------------------------
 
  Mod:  (newest to oldest)  
        DD-MMM-YYYY, My Name:
           Changed such and such to so and so. etc. etc.
        DD-MMM-YYYY, Your Name:
           More changes ... The ordering of the revision history 
           should be such that the NEWEST changes are at the HEAD of
           the list.
 
=============================================================================*/
#ifndef timeUtil_H
#define timeUtil_H 



#include <epicsTime.h>  /* epicsTimeStamp */


int      timeGetVMS(vmsTimeStamp_ta dest_a);
int      timeEpicsToVMS(const epicsTimeStamp* eTime_p, vmsTimeStamp_ta dest_a);
long int timeDiffVMS10usec(const vmsTimeStamp_ta ref_a, const vmsTimeStamp_ta later_a);
long int timeDiffVMS10msec(const vmsTimeStamp_ta ref_a, const vmsTimeStamp_ta later_a);
double   timeVMSDouble(const vmsTimeStamp_ta src_a);
  /* the following are debug routine only */
  /* the following SHOULD NOT BE CALLED BY PRODUCTION CODE */
void     timeEpicsFromVMS( const vmsTimeStamp_ta src_a, epicsTimeStamp* epicsTime_p);


#endif /*timeUtil_H*/
